﻿using Hotline.Application.CallCenter;
using Hotline.CallCenter.BlackLists;
using Hotline.Share.Dtos.CallCenter;
using Hotline.Share.Dtos.TrCallCenter;
using Microsoft.AspNetCore.Mvc;

namespace Hotline.Api.Controllers
{
    public class CallController : BaseController
    {
        private readonly ICallApplication _callApplication;

        public CallController(ICallApplication callApplication)
        {
            _callApplication = callApplication;
        }

        /// <summary>
        /// 查询分机
        /// </summary>
        [HttpGet("tels")]
        public Task<IReadOnlyList<TelDto>> QueryTelsAsync()
            => _callApplication.QueryTelsAsync(HttpContext.RequestAborted);

        /// <summary>
        /// 查询分机组
        /// </summary>
        [HttpGet("groups")]
        public Task<IReadOnlyList<TelGroupDto>> QueryTelGroupsAsync()
            => _callApplication.QueryTelGroupsAsync(HttpContext.RequestAborted);

        #region 黑名单

        //Task<string> AddBlackListAsync(AddBlacklistDto dto, CancellationToken cancellationToken);
        //Task RemoveBlackListAsync(string id, CancellationToken cancellationToken);
        //Task<List<Blacklist>> QueryBlackListsAsync(CancellationToken cancellationToken);

        #endregion

        /// <summary>
        /// 签入
        /// </summary>
        [HttpPost("signin")]
        public Task<TrOnDutyResponseDto> SignInAsync([FromBody] SignInDto dto)
            => _callApplication.SignInAsync(dto, HttpContext.RequestAborted);

        /// <summary>
        /// 签出
        /// </summary>
        [HttpPost("signout")]
        public Task SingOutAsync()
            => _callApplication.QueryTelsAsync(HttpContext.RequestAborted);
    }
}
