﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Hotline.CallCenter.BlackLists;
using Hotline.Share.Dtos.CallCenter;
using Hotline.Share.Dtos.TrCallCenter;

namespace Hotline.Application.CallCenter
{
    public interface ICallApplication
    {
        /// <summary>
        /// 查询分机
        /// </summary>
        Task<IReadOnlyList<TelDto>> QueryTelsAsync(CancellationToken cancellationToken);

        /// <summary>
        /// 查询分机组
        /// </summary>
        Task<IReadOnlyList<TelGroupDto>> QueryTelGroupsAsync(CancellationToken cancellationToken);

        #region 黑名单

        Task<string> AddBlackListAsync(AddBlacklistDto dto, CancellationToken cancellationToken);
        Task RemoveBlackListAsync(string id, CancellationToken cancellationToken);
        Task<List<Blacklist>> QueryBlackListsAsync(CancellationToken cancellationToken);

        #endregion

        /// <summary>
        /// 签入
        /// </summary>
        Task<TrOnDutyResponseDto> SignInAsync(SignInDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 签出
        /// </summary>
        Task SingOutAsync(CancellationToken cancellationToken);
    }
}
