﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Hotline.Application.CallCenter.Calls;
using Hotline.Application.Tels;
using Hotline.CallCenter.BlackLists;
using Hotline.Share.Dtos.CallCenter;
using Hotline.Share.Dtos.TrCallCenter;
using Hotline.Share.Enums.CallCenter;
using Microsoft.AspNetCore.Http;
using XF.Domain.Authentications;

namespace Hotline.Application.CallCenter
{
    public class TianRunCallApplication : ICallApplication
    {
        private readonly ISessionContext _sessionContext;
        private readonly ITrApplication _trApplication;
        private readonly ITelApplication _telApplication;

        public TianRunCallApplication(
            ISessionContext sessionContext,
            ITrApplication trApplication,
            ITelApplication telApplication)
        {
            _sessionContext = sessionContext;
            _trApplication = trApplication;
            _telApplication = telApplication;
        }

        public Task<IReadOnlyList<TelDto>> QueryTelsAsync(CancellationToken cancellationToken)
        {
            throw new NotImplementedException();
        }

        public Task<IReadOnlyList<TelGroupDto>> QueryTelGroupsAsync(CancellationToken cancellationToken)
        {
            throw new NotImplementedException();
        }

        public Task<string> AddBlackListAsync(AddBlacklistDto dto, CancellationToken cancellationToken)
        {
            throw new NotImplementedException();
        }

        public Task RemoveBlackListAsync(string id, CancellationToken cancellationToken)
        {
            throw new NotImplementedException();
        }

        public Task<List<Blacklist>> QueryBlackListsAsync(CancellationToken cancellationToken)
        {
            throw new NotImplementedException();
        }

        public async Task<TrOnDutyResponseDto> SignInAsync(SignInDto dto, CancellationToken cancellationToken)
        {
            return await _trApplication.OnSign(_sessionContext.RequiredUserId, dto.TelNo, (ETelModel)dto.TelModelState, cancellationToken);
        }

        public async Task SingOutAsync(CancellationToken cancellationToken)
        {
            await _telApplication.SignOutAsync(_sessionContext.RequiredUserId, cancellationToken);
        }
    }
}
